package policyauthor;

import javax.swing.ImageIcon;
import javax.swing.JMenuItem;

/**
 * A widget for a single possible selection for a given ACMatrixCell
 * (permit/deny/notapplicable)
 * 
 * @author Paul Freitas
 * 
 */
public class ACMatrixCellSelection extends JMenuItem {
	static ImageIcon[] images;
	static String[] decisionStrings = { "undefined", "notapplicable", "permit",
			"deny" };
	static boolean init = false;

	private String mRole;
	private String mAction;
	private int mDecision;

	public static final int NOTAPPLICABLE = 1;
	public static final int PERMIT = 2;
	public static final int DENY = 3;

	/**
	 * @param role
	 *            the role this corresponds to
	 * @param action
	 *            the action this corresponds to
	 * @param decision
	 *            the decision represented by this widget
	 */
	public ACMatrixCellSelection(String role, String action, int decision) {
		super("asdf");

		if (init == false) {
			// Load the decision images and create an array of indexes.
			images = new ImageIcon[decisionStrings.length];
			Integer[] intArray = new Integer[decisionStrings.length];
			for (int i = 0; i < decisionStrings.length; i++) {
				images[i] = new ImageIcon("icons/" + decisionStrings[i]
						+ ".gif");
				if (images[i] != null) {
					images[i].setDescription(decisionStrings[i]);
				}
			}

			init = true;
		}

		switch (decision) {
		case NOTAPPLICABLE:
			setText("Not Applicable");
			setIcon(images[NOTAPPLICABLE]);
			break;
		case PERMIT:
			setText("Permit");
			setIcon(images[PERMIT]);
			break;
		case DENY:
			setText("Deny");
			setIcon(images[DENY]);
			break;
		}
		mRole = role;
		mAction = action;
		mDecision = decision;
	}

	/**
	 * @return the role for this selection's parent cell
	 */
	public String getMRole() {
		return mRole;
	}

	/**
	 * @return the action for this selection's parent cell
	 */
	public String getMAction() {
		return mAction;
	}

	/**
	 * @return the decision that clicking this selects
	 */
	public int getMDecision() {
		return mDecision;
	}
}
