package policyauthor;

import javax.swing.JPanel;

/**
 * Parent class for a GUI element that creates & edits items for a ListCreator.
 * @author Paul Freitas
 *
 */
public abstract class ElementEditor extends JPanel {
	

	private ListCreator listener = null;
	
	/** 
	 * @param l the ListCreator that will receive the new items this creates
	 */
	public void attach(ListCreator l) {
		listener = l;
	}
	
	/**
	 * Edit an item already on the list
	 * @param item the thing to edit
	 * @return true if editing was started properly.
	 */
	public abstract boolean edit(Object item);
	
	/**
	 * Add a new entry to the listcreator
	 * @param item
	 */
	public void addEntry(Object item) {
		if(listener != null) {
			listener.addEntry(item);
		}
	}
}
