package policyauthor;

/**
 * Exception when a method call in an Access Control Matrix (ACMatrix)
 * references an action or a role which is not in that ACMatrix.
 * 
 * @author Paul Freitas
 * 
 */
public class NotInMatrixException extends RuntimeException {

	public static final int ROLE = 0;
	public static final int ACTION = 1;

	private boolean roleCause;

	public NotInMatrixException(int cause, String item) {
		super((cause == ROLE ? "Role" : "Action") + " \"" + item + "\""
				+ " not found in access control matrix.");
		roleCause = (cause == ROLE);
	}

	public boolean isRoleCause() {
		return roleCause;
	}
}
