package policyauthor;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class TextElementEditor extends ElementEditor {


	private JTextField newEntryField;
	private String typeName;
	
	public TextElementEditor(String itemTypeName) {
		typeName = itemTypeName;
		initialize();
	}
	
	public void initialize() {
		this.setLayout(new BoxLayout(this,
				BoxLayout.LINE_AXIS));
		this.add(new JLabel("New " + typeName + ": "));
		newEntryField = new JTextField(25);
		newEntryField.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent e) {
				// detect "Enter"
				if (e.getKeyCode() == e.VK_ENTER) {
					addEntryFromField();
				}
			}

			public void keyReleased(KeyEvent arg0) {
				// business as usual
			}

			public void keyTyped(KeyEvent arg0) {
				// business as usual
			}
		});
		this.add(newEntryField);
		JButton addButton = new JButton("Add " + typeName);
		addButton.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				addEntryFromField();
			}

		});
		this.add(addButton);

	}
	
	/**
	 * Add the string in the text field to the list.  If it's a duplicate, don't add it.
	 */
	private void addEntryFromField() {
		String toAdd = newEntryField.getText();
		addEntry(toAdd);
		// clear text field
		newEntryField.setText("");
	}

	@Override
	public boolean edit(Object item) {
		if(item instanceof String) {
			newEntryField.setText((String) item);
			return true;
		} else {
			return false;
		}
	}

}
