package policyauthor.conflict;

import javax.script.ScriptException;

import edu.wpi.cetask.TaskEngine;
import policyauthor.constraint.ConstraintTemplate;

public class Conflict {

	private String rs;
	private TaskEngine e;
	
	private String BASE_WHERE;
	
	public Conflict(String retrieveString,TaskEngine engine) throws ConflictException {
		rs = retrieveString;
		e = engine;
		BASE_WHERE = "Conflict '" + rs + "'";
		//make sure rs is valid
		try {
			if(e.evalGlobal(rs, BASE_WHERE) == null || e.evalGlobal(rs + ".constraint",BASE_WHERE) == null) {
				throw new ConflictException("Script '" + rs + "' does not return a ConflictDesignator object.");
			}
		} catch (ScriptException e1) {
			throw new ConflictException("Script '" + rs + "' does not return a ConflictDesignator object.");
		}
	}
	
	public void setRetrieveString(String rs) {
		this.rs = rs;
	}
	
	public String getRetrieveString() {
		return rs;
	}
	
	public String getRole() throws ScriptException {
		int length = ((Double)e.evalGlobal(rs + ".roleset" + ".length", "ConflictList.setListData()")).intValue();

		String roles[] = new String[length];
		for(int i = 0; i < length; i++) {
			roles[i] = (String)e.evalGlobal(rs + ".roleset"+ "[" + i + "]", BASE_WHERE + ".getRole()");
		}
		
		String ret = roles[0];
		for(int i = 1; i < roles.length; i++) {
			ret += "/";
			ret += roles[i];
		}
		return ret;
	}

	public String getAction() throws ScriptException {
		String action = (String)e.evalGlobal(rs + ".col",BASE_WHERE + ".getAction()");
		return action;
	}

	public ConstraintTemplate getConstraint() throws ScriptException {
		ConstraintTemplate ct = new ConstraintTemplate(e);
		ct.setToConstraintInstance(rs + ".constraint");
		return ct;
	}
	
	public ConflictResolver[] getConflictResolvers() throws ScriptException {
		int len = ((Double)e.evalGlobal(rs + ".cresolvers.length", BASE_WHERE + ".getConflictResolver()")).intValue();
		
		ConflictResolver ret[] = new ConflictResolver[len];
		
		for(int i = 0; i < len; i++) {
			ret[i] = new ConflictResolver(rs + ".cresolvers[" + i + "]",e);
		}
		
		return ret;
	}

}
