package policyauthor.conflict;

import java.awt.*;
import java.util.Vector;

import javax.script.ScriptException;
import javax.swing.BoxLayout;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.ListCellRenderer;
import javax.swing.ListModel;
import javax.swing.border.LineBorder;

import policyauthor.ListCreator;
import policyauthor.constraint.ActionSelector;
import policyauthor.constraint.ConstraintMaker;
import policyauthor.constraint.RoleSelector;
import edu.wpi.cetask.TaskEngine;
import edu.wpi.cetask.guide.Guide;


public class ConflictList extends JList {

	private class ConflictListRenderer extends DefaultListCellRenderer {
		@Override
		public Component getListCellRendererComponent(JList list, Object value,
				int index, boolean isSelected, boolean cellHasFocus) {
			try {
				if(value instanceof Conflict) {
					JPanel ret = new JPanel();
					ret.setBorder(new LineBorder(Color.BLACK,2) );
					if(isSelected) {
						ret.setForeground(list.getSelectionForeground());
						ret.setBackground(list.getSelectionBackground());
					} else {
						ret.setForeground(list.getForeground());
						ret.setBackground(list.getBackground());
					}
					Conflict c = (Conflict)value;
					ret.add(new JLabel("Cell: (" + c.getRole() + "," + c.getAction() + ")"));
					ret.add(new JLabel("  " + c.getConstraint().getPrintString()));
					return ret; 
				}
			} catch(ScriptException e) {
				e.printStackTrace();
			}
			return super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
		}
	}
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 7907435225070092844L;

	public ConflictList() {
		super();
		this.setCellRenderer(new ConflictListRenderer());
	}
	
	public ConflictList(ListModel dataModel) {
		super(dataModel);
		this.setCellRenderer(new ConflictListRenderer());
	}
	
	public ConflictList(Object[] listData) {
		super(listData);
		this.setCellRenderer(new ConflictListRenderer());
	}
	
	public ConflictList(Vector listData) {
		super(listData);
		this.setCellRenderer(new ConflictListRenderer());
	}
	
	/*Doesn't work atm
	 * public ConflictList(String retrievalScript,TaskEngine e) throws ScriptException {
		super((Object[])e.evalGlobal(retrievalScript, "ConflictList"));
		this.setCellRenderer(new ConflictListRenderer());
	}*/
	
	public void setListData(String clistScript,TaskEngine e) throws ScriptException, ConflictException {
		int length = ((Double)e.evalGlobal(clistScript + ".length", "ConflictList.setListData()")).intValue();
		
		Conflict clist[] = new Conflict[length];
		
		for(int i = 0; i < length; i++) {
			clist[i] = new Conflict(clistScript + "[" + i + "]",e);
		}
		
		setListData(clist);
		repaint();
	}
	
	public static void main(String args[]) {
		JFrame frame = new JFrame("ConflictList test");

		frame.getContentPane().setLayout(
				new BoxLayout(frame.getContentPane(), BoxLayout.PAGE_AXIS));
		
		Guide g = new Guide(null);
		g.verbose("true");
		g.executeSource("test/policytaskmodelBAD1");
		
		ConflictList cl = new ConflictList();
		try {
			cl.setListData("$conflicts",g.getEngine());
		} catch (ScriptException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ConflictException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		frame.getContentPane().add(cl);

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		frame.setVisible(true);
	}
}
