package policyauthor.conflict;

import javax.script.ScriptException;

import policyauthor.ACMatrixCellSelection;
import policyauthor.constraint.ConstraintTemplate;

import edu.wpi.cetask.TaskEngine;

public class ConflictResolver {
	
	private String rs;
	private TaskEngine e;
	private String BASE_WHERE;
	private String crType;
	
	public ConflictResolver(String getStr, TaskEngine engine) throws ScriptException {
		rs = getStr;
		e = engine;
		BASE_WHERE = "ConflictResolver '" + rs + "'";
		
		//get CRType
		crType = (String) e.evalGlobal(rs + ".crType", BASE_WHERE);
	}

	public String getCrType() {
		return crType;
	}

	public void setCrType(String crType) {
		this.crType = crType;
	}

	public String getRetrievalScript() {
		return rs;
	}
	
	public ConstraintTemplate getConstraint() throws ScriptException, ConflictResolverTypeException {
		ConstraintTemplate ct = new ConstraintTemplate(e);
		if(crType.equals("addConstraint") || crType.equals("remConstraint")) {
			ct.setToConstraintInstance(rs + ".constraint");
			return ct;
		} else {
			throw new ConflictResolverTypeException("getConstraint() not applicable for ConflictResolver type " + crType);
		}
	}
	
	public String getRow() throws ScriptException, ConflictResolverTypeException {
		if(crType.equals("changeDec")) {
			return (String)e.evalGlobal(rs + ".row", BASE_WHERE +".getRow()");
		} else {
			throw new ConflictResolverTypeException("getRow() not applicable for ConflictResolver type " + crType);
		}
	}
	
	public String getCol() throws ScriptException, ConflictResolverTypeException {
		if(crType.equals("changeDec")) {
			return (String)e.evalGlobal(rs + ".col", BASE_WHERE +".getCol()");
		} else {
			throw new ConflictResolverTypeException("getCol() not applicable for ConflictResolver type " + crType);
		}
	}
	
	public int getNewDec() throws ScriptException, ConflictResolverTypeException {
		if(crType.equals("changeDec")) {
			if((Boolean)e.evalGlobal(rs + ".newDec == ACDecision.PERMIT", BASE_WHERE +".getCol()")) {
				return ACMatrixCellSelection.PERMIT;
			} else if((Boolean)e.evalGlobal(rs + ".newDec == ACDecision.DENY", BASE_WHERE +".getCol()")) {
				return ACMatrixCellSelection.DENY;
			} else {
				return ACMatrixCellSelection.NOTAPPLICABLE;
			}
		} else {
			throw new ConflictResolverTypeException("getNewDec() not applicable for ConflictResolver type " + crType);
		}
	}

}
