package policyauthor.constraint;

import javax.swing.JComboBox;

/**
 * ComboBox variant for selecting an Access Control Action. Always contains the
 * same list of actions, and may be tied to a ConstraintTemplate argument.
 * 
 * @author Paul Freitas
 */
public class ActionSelector extends JComboBox implements ArgObserver {
	/**
	 * 
	 */
	private static final long serialVersionUID = -7037829043944931156L;
	/**
	 * The actions that any ActionSelector may represent.
	 */
	private static String[] actions;

	/**
	 * Set the list of possible actions.
	 * 
	 * @param a
	 */
	public static void setActions(String[] a) {
		actions = new String[a.length];
		System.arraycopy(a, 0, actions, 0, a.length);
	}

	/**
	 * Default Constructor
	 */
	public ActionSelector() {
		super(actions);
	}

	/**
	 * the value of the argument this selector is linked to changed. Update the
	 * selector.
	 */
	public void update(ConstraintTemplate constraintTemplate, int argNum,
			String newVal) {
		this.setSelectedItem(newVal);
		repaint();
	}
}
