package policyauthor.constraint;

/**
 * Interface for anything that observes the value of an argument in a
 * ConstraintTemplate.
 * 
 * @author Paul Freitas
 */
public interface ArgObserver {

	/**
	 * The argument this observes was changed. Update!
	 * 
	 * @param constraintTemplate
	 *            the ConstraintTemplate that holds the argument
	 * @param argNum
	 *            the index of the argument that changed
	 * @param newVal
	 *            the new value of that argument.
	 */
	void update(ConstraintTemplate constraintTemplate, int argNum, String newVal);

}
