package policyauthor.constraint;

import java.awt.Component;

import javax.swing.BoxLayout;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import edu.wpi.cetask.TaskEngine;
import edu.wpi.cetask.guide.Guide;

import policyauthor.ElementEditor;
import policyauthor.ListCreator;
import policyauthor.TextElementEditor;

/**
 * JPanel for creating a set of constraints.
 * @author Paul Freitas
 *
 */
public class ConstraintMaker extends ListCreator {
	
	public ConstraintMaker(TaskEngine engine) {
		super("Constraints" , new ConstraintElementEditor(engine));
		list.setCellRenderer(new ConstraintTypeRenderer());
	}

	class ConstraintTypeRenderer extends DefaultListCellRenderer {
		
		@Override
		public Component getListCellRendererComponent(JList list, Object value,
				int index, boolean isSelected, boolean cellHasFocus) {
			if(value instanceof ConstraintTemplate) {
				JLabel retval = new JLabel(((ConstraintTemplate)value).getPrintString());
				if(isSelected) {
					retval.setForeground(list.getSelectionForeground());
					retval.setBackground(list.getSelectionBackground());
				} else {
					retval.setForeground(list.getForeground());
					retval.setBackground(list.getBackground());
				}
				retval.setOpaque(true);
				return retval;
			} else {
				return super.getListCellRendererComponent(list, value,
						index, isSelected, cellHasFocus);
			}
		}
		
	}
	
	public static void main(String args[]) {
		JFrame frame = new JFrame("ConstraintMaker test");

		String roles[] = new String[3];
		roles[0] = "owner";
		roles[1] = "group";
		roles[2] = "all";

		String actions[] = new String[3];
		actions[0] = "read";
		actions[1] = "write";
		actions[2] = "execute";

		frame.getContentPane().setLayout(
				new BoxLayout(frame.getContentPane(), BoxLayout.PAGE_AXIS));

		ActionSelector.setActions(actions);
		RoleSelector.setRoles(roles);
		
		
		Guide g = new Guide(null);
		g.load("models/policytaskmodel.xml");
		
		ListCreator lc = new ConstraintMaker(g.getEngine());

		frame.getContentPane().add(lc);

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		frame.setVisible(true);
	}
}
