package policyauthor.constraint;

import javax.swing.JComboBox;

/**
 * ComboBox variant for selecting an Access Control Role. Always contains the
 * same list of roles, and may be tied to a ConstraintTemplate argument.
 * 
 * @author Paul Freitas
 */
public class RoleSelector extends JComboBox implements ArgObserver {
	/**
	 * 
	 */
	private static final long serialVersionUID = 6155767008871441304L;

	/**
	 * The roles that any RoleSelector may represent.
	 */
	private static String[] roles;

	/**
	 * Set the list of possible roles.
	 * 
	 * @param a
	 */
	public static void setRoles(String[] r) {
		roles = new String[r.length];
		System.arraycopy(r, 0, roles, 0, r.length);
	}

	/**
	 * Default Constructor
	 */
	public RoleSelector() {
		super(roles);
	}

	/**
	 * the value of the argument this selector is linked to changed. Update the
	 * selector.
	 */
	public void update(ConstraintTemplate constraintTemplate, int argNum,
			String newVal) {
		this.setSelectedItem(newVal);
		repaint();
	}
}
