package policyauthor.jsvars;

import java.util.ArrayList;

import javax.script.ScriptException;

public class JSArray extends JSVar {
	/**
	 * Get a member of this variable, if it is an object
	 * @param mname the name of the member to retrieve
	 * @return the value of the specified member
	 * @throws ScriptException if retrieval of the specified member fails
	 */
	public Object get(int index) throws ScriptException {
		return engine.evalGlobal(retrievalScript + "[" + index + "]", 
				baseWhere() + " JSObject.get(" + index + ")");
	}
	
	public int getLength() throws ScriptException {
		return ((Integer)engine.evalGlobal(retrievalScript + ".length", 
					baseWhere() + " JSObject.getLength()")).intValue();
	}
	
	public ArrayList getAsArrayList() throws ScriptException {
		ArrayList ret = new ArrayList(getLength());
		for(int i = 0; i < getLength(); i++) {
			ret.set(i,get(i));
		}
		
		return ret;
	}
	
	public <T> ArrayList<T> getAsArrayList(T exObj) throws ScriptException {
		int count = 0;
		for(int i = 0; i < getLength(); i++) {
			if(get(i).getClass().isInstance(exObj.getClass())) {
				count++;
			} else {
				System.err.println("WARNING: " + baseWhere() + " element at index " + i + "is not of type " + exObj.getClass() + ". Skipping in conversion to Java array.");
			}
		}
		ArrayList<T> ret = new ArrayList<T>(count);
		int j = 0;
		for(int i = 0; i < getLength() && j < count; i++) {
			if(get(i).getClass().isInstance(exObj.getClass())) {
				ret.set(j, (T) get(i));
				j++;
			}
		}
		
		return ret;
	}
}
