package policyauthor.jsvars;

import javax.script.ScriptException;

public class JSObject extends JSVar {
	/**
	 * Get a member of this variable, if it is an object
	 * @param mname the name of the member to retrieve
	 * @return the value of the specified member
	 * @throws ScriptException if retrieval of the specified member fails
	 */
	public Object getMember(String mname) throws ScriptException {
		return engine.evalGlobal(retrievalScript + "." + mname, 
				baseWhere() + " JSObject.getMember('" + mname + "')");
	}
	
	/**
	 * Get a member of this variable, if it is an object, and return it as a JSVar
	 * @param mname the name of the member to retrieve
	 * @return a JSVar with the specified member as its target
	 * @throws ScriptException if retrieval of the specified member fails
	 */
	public JSVar getMemberAsJSVar(String mname) throws ScriptException {
		return new JSVar(retrievalScript + "." + mname,engine);
	}
	
	/**
	 * Set a member of the variable to a value
	 * @param mname the name of the member to set
	 * @param valueScript the value to set the member to
	 * @throws ScriptException if setting the member to that value fails
	 */
	public void setMember(String mname, String valueScript) throws ScriptException {
		engine.evalGlobal(retrievalScript + "." + mname + " = " + valueScript, 
				baseWhere() + " JSObject.setMember('" + mname + "','" + valueScript + "')");
	}
}
